#ifndef CONVERTTOSERIES_H
#define CONVERTTOSERIES_H

#include <QObject>
#include <QRunnable>
#include <QMutex>
#include <QLineSeries>
#include "dataresult1d.h"

using namespace QtCharts;

class ConvertToSeries : public QObject, public QRunnable {
    Q_OBJECT
public:
    explicit ConvertToSeries(QObject *parent = nullptr);

private:
    QMutex mutex;
    bool dataPresent = false;
    DataResult1D data;
    QLineSeries *series;

    void run() override;

public:
    void setData(QLineSeries *series, const DataResult1D &data);

signals:
    void dataConverted(QLineSeries *series, QString entityId, double, double);

};

#endif // CONVERTTOSERIES_H
